class com.rightactionscript.fcb.components.UIBasicComponent extends MovieClip
{
   var __width;
   var __height;
   var _nOriginalWidth;
   var _nOriginalHeight;
   var mcBoundingBox;
   var onEnterFrame;
   var _mcFrame;
   var _nScaleX = 100;
   var _nScaleY = 100;
   var _aQueue = new Array();
   var clipParameters = {};
   function UIBasicComponent()
   {
      super();
      this.init();
      this.createChildren();
      this.draw();
      this.arrange();
   }
   static function mergeClipParameters(oA, oB)
   {
      for(var _loc2_ in oA)
      {
         oA[_loc2_] = oB[_loc2_];
      }
      return true;
   }
   function set width(nWidth)
   {
      this.setSize(nWidth,null);
   }
   function get width()
   {
      return this.__width;
   }
   function set height(nHeight)
   {
      this.setSize(null,nHeight);
   }
   function get height()
   {
      return this.__height;
   }
   function set scaleX(nScaleX)
   {
      this._nScaleX = nScaleX;
      this._xscale = this._nScaleX;
      this.onScale();
   }
   function set scaleY(nScaleY)
   {
      this._nScaleY = nScaleY;
      this._yscale = this._nScaleY;
      this.onScale();
   }
   function init(bDontHideBoundingBox)
   {
      this.__width = this._width;
      this.__height = this._height;
      this._nOriginalWidth = this._width;
      this._nOriginalHeight = this._height;
      if(!bDontHideBoundingBox)
      {
         this.mcBoundingBox._visible = false;
         this.mcBoundingBox._height = 0;
         this.mcBoundingBox._width = 0;
      }
      this.size();
      mx.events.EventDispatcher.initialize(this);
   }
   function setSize(w, h)
   {
      if(w != undefined && w != null)
      {
         this.__width = w;
      }
      else
      {
         this.__width = this._width;
      }
      if(h != undefined && h != null)
      {
         this.__height = h;
      }
      else
      {
         this.__height = this._height;
      }
      this.size();
   }
   function createChildren()
   {
   }
   function draw()
   {
   }
   function size()
   {
      this._xscale = this._nScaleX;
      this._yscale = this._nScaleY;
   }
   function arrange()
   {
      this._width = this.__width;
      this._height = this.__height;
   }
   function addToQueue(oCall)
   {
      this._aQueue.push(oCall);
      if(this.onEnterFrame == undefined)
      {
         this.onEnterFrame = this.runQueue;
      }
   }
   function runQueue()
   {
      var _loc2_ = this._aQueue.shift();
      _loc2_.method.apply(_loc2_.object,_loc2_.params);
      if(this._aQueue.length == 0)
      {
         delete this.onEnterFrame;
      }
   }
   function drawFrame()
   {
      if(this._mcFrame == undefined)
      {
         this.createEmptyMovieClip("_mcFrame",this.getNextHighestDepth());
      }
      var _loc2_ = 1;
      this._mcFrame.clear();
      this._mcFrame.lineStyle(_loc2_,7305079,100);
      this._mcFrame.lineTo(this.__width,0);
      this._mcFrame.lineStyle(_loc2_,9542041,100);
      this._mcFrame.lineTo(this.__width,this.__height);
      this._mcFrame.lineStyle(_loc2_,14015965,100);
      this._mcFrame.lineTo(0,this.__height);
      this._mcFrame.lineStyle(_loc2_,9542041,100);
      this._mcFrame.lineTo(0,0);
      this._mcFrame.moveTo(1,1);
      this._mcFrame.lineStyle(_loc2_,13290700,100);
      this._mcFrame.lineTo(this.__width - 1,1);
      this._mcFrame.lineStyle(_loc2_,14015965,100);
      this._mcFrame.lineTo(this.__width - 1,this.__height - 1);
      this._mcFrame.lineStyle(_loc2_,15658734,100);
      this._mcFrame.lineTo(1,this.__height - 1);
      this._mcFrame.lineStyle(_loc2_,14015965,100);
      this._mcFrame.lineTo(1,1);
   }
   function onScale()
   {
   }
}
